searchData={"items":[{"type":"module","title":"SSD1306","doc":"SSD1306 Driver for Elixir using ElixirALE.","ref":"SSD1306.html"},{"type":"module","title":"Usage: - SSD1306","doc":"Add your devices to your config like so:\n\n    config :ssd1306,\n      devices: [\n        %{bus: \"i2c-1\", address: 0x3d, reset_pin: 17}\n      ]\n\nThen use the functions in [SSD1306.Device] to send image data.\nPretty simple.","ref":"SSD1306.html#module-usage"},{"type":"function","title":"SSD1306.connect/1","doc":"Connect to an SSD1306 device.","ref":"SSD1306.html#connect/1"},{"type":"function","title":"SSD1306.disconnect/1","doc":"Disconnect an SSD1306 device.","ref":"SSD1306.html#disconnect/1"},{"type":"module","title":"SSD1306.Commands","doc":"This module contains all the constants and commands for manipulating the\nSSD1306 device.  More information about the available commands can be found in\nthe _COMMAND TABLE_ section of the\n[Datasheet](https://cdn-shop.adafruit.com/datasheets/SSD1306.pdf).\n\nFor simple use cases you will most likely want to simply use the\n`SSD1306.Device` module to automatically handle your display needs, however if\nyou have something more complicated in mind then you can use the functions in\nthis module to interact with an I2C device directly.","ref":"SSD1306.Commands.html"},{"type":"function","title":"SSD1306.Commands.activate_scroll!/1","doc":"set activate scroll","ref":"SSD1306.Commands.html#activate_scroll!/1"},{"type":"function","title":"SSD1306.Commands.charge_pump/2","doc":"set charge pump","ref":"SSD1306.Commands.html#charge_pump/2"},{"type":"function","title":"SSD1306.Commands.column_address/3","doc":"set column address","ref":"SSD1306.Commands.html#column_address/3"},{"type":"function","title":"SSD1306.Commands.com_pins/2","doc":"set com pins","ref":"SSD1306.Commands.html#com_pins/2"},{"type":"function","title":"SSD1306.Commands.com_scan_dec!/1","doc":"set com scan dec","ref":"SSD1306.Commands.html#com_scan_dec!/1"},{"type":"function","title":"SSD1306.Commands.com_scan_inc!/1","doc":"set com scan inc","ref":"SSD1306.Commands.html#com_scan_inc!/1"},{"type":"function","title":"SSD1306.Commands.contrast/2","doc":"set contrast","ref":"SSD1306.Commands.html#contrast/2"},{"type":"function","title":"SSD1306.Commands.deactivate_scroll!/1","doc":"set deactivate scroll","ref":"SSD1306.Commands.html#deactivate_scroll!/1"},{"type":"function","title":"SSD1306.Commands.display/2","doc":"Send a frame to the display.\n\nArguments:\n  * A map with `:i2c` set to the I2C connection pid, `:width` and `:height` in pixels.\n  * A bytestring containing the buffer to be displayed.","ref":"SSD1306.Commands.html#display/2"},{"type":"function","title":"SSD1306.Commands.display_all_on!/1","doc":"set display all on","ref":"SSD1306.Commands.html#display_all_on!/1"},{"type":"function","title":"SSD1306.Commands.display_all_on_resume!/1","doc":"set display all on resume","ref":"SSD1306.Commands.html#display_all_on_resume!/1"},{"type":"function","title":"SSD1306.Commands.display_clock_div/2","doc":"display clock div","ref":"SSD1306.Commands.html#display_clock_div/2"},{"type":"function","title":"SSD1306.Commands.display_off!/1","doc":"set display off","ref":"SSD1306.Commands.html#display_off!/1"},{"type":"function","title":"SSD1306.Commands.display_offset/2","doc":"set display offset","ref":"SSD1306.Commands.html#display_offset/2"},{"type":"function","title":"SSD1306.Commands.display_on!/1","doc":"set display on","ref":"SSD1306.Commands.html#display_on!/1"},{"type":"function","title":"SSD1306.Commands.high_column/2","doc":"set high column","ref":"SSD1306.Commands.html#high_column/2"},{"type":"function","title":"SSD1306.Commands.initialize!/1","doc":"Initialize the device using \"sane defaults\" based on the display size.\n\nConfigurable options (configure by adding these keys to your device's keys\nin your application configuration) and their defaults below:\n\n    config :ssd1306,\n      device: [%{\n        display_clock_div: 0x80,\n        multiplex: 0x3f,\n        external_vcc: false,\n        charge_pump: 0x10, # or 0x14 if :external_vcc is true\n        memory_mode: 0x80,\n        segment_remap: 0x01,\n        com_pins: 0x12,\n        contrast: 0x9f, # or 0xcf if :external_vcc is true\n        pre_charge: 0x22, # or 0xf1 if :external_vcc is true\n        vcom_detect: 0x40\n      }]","ref":"SSD1306.Commands.html#initialize!/1"},{"type":"function","title":"SSD1306.Commands.invert_display!/1","doc":"set invert display","ref":"SSD1306.Commands.html#invert_display!/1"},{"type":"function","title":"SSD1306.Commands.left_horizontal_scroll!/1","doc":"set left horizontal scroll","ref":"SSD1306.Commands.html#left_horizontal_scroll!/1"},{"type":"function","title":"SSD1306.Commands.low_column/2","doc":"set low column","ref":"SSD1306.Commands.html#low_column/2"},{"type":"function","title":"SSD1306.Commands.memory_mode/2","doc":"set memory node","ref":"SSD1306.Commands.html#memory_mode/2"},{"type":"function","title":"SSD1306.Commands.multiplex/2","doc":"set multiplex","ref":"SSD1306.Commands.html#multiplex/2"},{"type":"function","title":"SSD1306.Commands.normal_display!/1","doc":"set normal display","ref":"SSD1306.Commands.html#normal_display!/1"},{"type":"function","title":"SSD1306.Commands.page_address/3","doc":"set page address","ref":"SSD1306.Commands.html#page_address/3"},{"type":"function","title":"SSD1306.Commands.pre_charge/2","doc":"set pre charge","ref":"SSD1306.Commands.html#pre_charge/2"},{"type":"function","title":"SSD1306.Commands.reset!/1","doc":"Reset the SSD1306 using the GPIO reset pin.","ref":"SSD1306.Commands.html#reset!/1"},{"type":"function","title":"SSD1306.Commands.right_horizontal_scroll!/1","doc":"set right horizontal scroll","ref":"SSD1306.Commands.html#right_horizontal_scroll!/1"},{"type":"function","title":"SSD1306.Commands.segment_remap/2","doc":"set segment remap","ref":"SSD1306.Commands.html#segment_remap/2"},{"type":"function","title":"SSD1306.Commands.start_line/2","doc":"set start line","ref":"SSD1306.Commands.html#start_line/2"},{"type":"function","title":"SSD1306.Commands.vcom_detect/2","doc":"set vcom detect","ref":"SSD1306.Commands.html#vcom_detect/2"},{"type":"function","title":"SSD1306.Commands.vertical_and_left_horizontal_scroll!/1","doc":"set vertical and left horizontal scroll","ref":"SSD1306.Commands.html#vertical_and_left_horizontal_scroll!/1"},{"type":"function","title":"SSD1306.Commands.vertical_and_right_horizontal_scroll!/1","doc":"set vertical and right horizontal scroll","ref":"SSD1306.Commands.html#vertical_and_right_horizontal_scroll!/1"},{"type":"function","title":"SSD1306.Commands.vertical_scroll_area/2","doc":"set vertical scroll area","ref":"SSD1306.Commands.html#vertical_scroll_area/2"},{"type":"module","title":"SSD1306.Device","doc":"An individual SSD1306 device.\n\nEach device needs it's configuration specified in your application's\nconfiguration.\n\nExample configuration:\n\n    config :ssd1306,\n      devices: [\n        %{bus: \"i2c-1\", address: 0x3D, name: :display0, width: 128, height: 32}\n      ]\n\nNote that `bus` and `address` are required, `width` and `height` are optional\nand default to `128` and `64` respectively.\n\n`name` is also optional and allows you to specify an arbitrary name to\nregister this device as in `ssd1306`'s process registry.  You can then use\nthis name when using the public functions in this module to refer to a\nspecific device.  If not provided then a tuple of the bus name and address\nwill be used, for example the device above would be named `{\"i2c-1\", 0x3D}` if\nthe `name` value had not been set.","ref":"SSD1306.Device.html"},{"type":"function","title":"SSD1306.Device.all_off/1","doc":"Turn off all pixels of the attached device.","ref":"SSD1306.Device.html#all_off/1"},{"type":"function","title":"SSD1306.Device.all_on/1","doc":"Turn on all pixels of the attached device.","ref":"SSD1306.Device.html#all_on/1"},{"type":"function","title":"SSD1306.Device.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"SSD1306.Device.html#child_spec/1"},{"type":"function","title":"SSD1306.Device.display/2","doc":"Send the contents of `buffer` to the device for display.","ref":"SSD1306.Device.html#display/2"},{"type":"function","title":"SSD1306.Device.execute/2","doc":"Send arbitrary commands to the device.\n\nThis is useful for any advanced usage that doesn't involve just sending a\nbuffer to the display.\n\nThe `function` argument is a function which will be called from within the\ndevice process with the PID of the I2C connection as it's only argument.  Be\naware that if this function takes a while to execute the device will be unable\nto respond to other messages.\n\nThe commands are listed in the [SSD1306.Commands] module, and information\nabout them can be found in the\n[SSD1306 Datasheet](https://cdn-shop.adafruit.com/datasheets/SSD1306.pdf).","ref":"SSD1306.Device.html#execute/2"},{"type":"function","title":"Example - SSD1306.Device.execute/2","doc":"To invert the display.\n\n    iex> alias SSD1306.{Device, Commands}\n    ...> Device.commands({\"i2c-1\", 0x3D}, fn pid -> Commands.invert_display!(pid) end)\n    :ok","ref":"SSD1306.Device.html#execute/2-example"},{"type":"function","title":"SSD1306.Device.initialize_buffer/2","doc":"","ref":"SSD1306.Device.html#initialize_buffer/2"},{"type":"type","title":"SSD1306.Device.address/0","doc":"","ref":"SSD1306.Device.html#t:address/0"},{"type":"type","title":"SSD1306.Device.buffer/0","doc":"","ref":"SSD1306.Device.html#t:buffer/0"},{"type":"type","title":"SSD1306.Device.bus/0","doc":"","ref":"SSD1306.Device.html#t:bus/0"},{"type":"type","title":"SSD1306.Device.device_name/0","doc":"","ref":"SSD1306.Device.html#t:device_name/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,49]}}